`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    15:32:02 05/26/2016 
// Design Name: 
// Module Name:    binary_counter 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////


// 3200 MHz version
/*
module binary_counter_original(
    input clk,
	 input aresetn,
    input pps,
    output [9:0] val
    );

reg [9:0] usec = 10'd0;
reg [12:0] int_cnt_reg = 13'd0;
reg reset_done = 1'b0;

always @(negedge clk, negedge aresetn)
begin
	if(aresetn == 1'b0)
		begin
			reset_done <= 1'b0;
			int_cnt_reg <= 13'd0;
			usec <= 10'd0;
		end
	else if(pps  == 1'b1 & reset_done == 1'b0)
		begin
			int_cnt_reg <= 13'd0;
			usec <= 10'd0;
			reset_done <= 1'b1;
		end

	else
		begin
			// check if we have pps pulse in proper place ( in the middle of 10uS pulse that has been captured at initial stage)
			if(pps == 1'b0)
				reset_done <= 1'b0;

			//one cycle used for actual nulling this reg
			if(int_cnt_reg < 13'd6399) begin
				int_cnt_reg <= int_cnt_reg+1;
			end else begin
				int_cnt_reg <= 13'd0;
				//if(usec < 10'd999) begin
					usec <= usec+1;
				//end else begin
				//	usec <= 10'd0;
				//end
			end
		end

end




assign val = usec;

endmodule
*/




module binary_counter(
    input clk,
	 input aresetn,
    input pps,
    input set_time,
    input  [31:0] time_in,
    output [41:0] val_time
    );

reg [9:0] msec = 10'd0;
reg [12:0] int_cnt_reg = 13'd0;
reg reset_done = 1'b0;
reg [31:0] time_val;
reg [1:0] time_is_setted;
reg time_is_setted2;
//reg [2:0] delayed_state = 3'b000; //128



always @(posedge clk, negedge aresetn)
begin
	if(aresetn == 1'b0)
		begin
			reset_done <= 1'b0;
			int_cnt_reg <= 13'd0;
			msec <= 10'd0;
			time_is_setted <= 2'd0;
			time_val <= 32'hFFFFFFFF;

		end
	else if(pps  == 1'b1 & reset_done == 1'b0)
		begin
			int_cnt_reg <= 13'd0;
			msec <= 10'd0;
			reset_done <= 1'b1;
			if (set_time == 1'b1 && time_is_setted < 2'd2) begin
				if(time_is_setted == 2'd1 && time_val != time_in)
					time_is_setted <= 2'd2;
				else
					time_is_setted <= 2'd1;
				time_val <= time_in;
			end

			if (time_is_setted == 2'd2)
//			if (time_is_setted == 1'b1)
			begin
				time_val<=time_val+1;
			end
		end
	else
		begin
			// check if we have pps pulse in proper place (
			// in the middle of 10uS pulse that has been captured at initial stage)
			// we also lost 1 clock pulse here...
			if(pps == 1'b0)
				reset_done <= 1'b0;

			//one cycle used for actual nulling this reg
			if(int_cnt_reg < 13'd6399) begin
				int_cnt_reg <= int_cnt_reg+1;
			end else begin
				int_cnt_reg <= 13'd0;
				//if(msec < 10'd999) begin
				msec <= msec+1;
				//end else begin
				//	msec <= 10'd0;
				//end
			end
		end

end






/*
//for clock
reg [9:0] usec; //1024
reg [5:0] sec;  //64
reg [5:0] min;  //64
reg [4:0] hour; //32
//for calendar
reg [4:0] day;  //32
reg [3:0] month;//16
reg [6:0] year; //128
*/


//assign val_time = { 32'd0, msec };
assign val_time = { time_val, msec };

endmodule
