-- ==============================================================
-- RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
-- Version: 2014.1
-- Copyright (C) 2014 Xilinx Inc. All rights reserved.
-- 
-- ===========================================================

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity deinterleave_samples is
port (
    ap_clk : IN STD_LOGIC;
    ap_rst : IN STD_LOGIC;
    input_V_V_dout : IN STD_LOGIC_VECTOR (31 downto 0);
    input_V_V_empty_n : IN STD_LOGIC;
    input_V_V_read : OUT STD_LOGIC;
    output_V_V_din : OUT STD_LOGIC_VECTOR (15 downto 0);
    output_V_V_full_n : IN STD_LOGIC;
    output_V_V_write : OUT STD_LOGIC );
end;


architecture behav of deinterleave_samples is 
    attribute CORE_GENERATION_INFO : STRING;
    attribute CORE_GENERATION_INFO of behav : architecture is
    "deinterleave_samples,hls_ip_2014_1,{HLS_INPUT_TYPE=cxx,HLS_INPUT_FLOAT=0,HLS_INPUT_FIXED=1,HLS_INPUT_PART=xc6slx9tqg144-2,HLS_INPUT_CLOCK=10.000000,HLS_INPUT_ARCH=others,HLS_SYN_CLOCK=0.000000,HLS_SYN_LAT=-1,HLS_SYN_TPT=none,HLS_SYN_MEM=0,HLS_SYN_DSP=0,HLS_SYN_FF=0,HLS_SYN_LUT=0}";
    constant ap_const_logic_1 : STD_LOGIC := '1';
    constant ap_const_logic_0 : STD_LOGIC := '0';
    constant ap_ST_st1_fsm_0 : STD_LOGIC_VECTOR (1 downto 0) := "00";
    constant ap_ST_st2_fsm_1 : STD_LOGIC_VECTOR (1 downto 0) := "01";
    constant ap_ST_st3_fsm_2 : STD_LOGIC_VECTOR (1 downto 0) := "10";
    constant ap_const_lv32_10 : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000010000";
    constant ap_const_lv32_1F : STD_LOGIC_VECTOR (31 downto 0) := "00000000000000000000000000011111";

    signal tmp_V_1_reg_69 : STD_LOGIC_VECTOR (15 downto 0);
    signal ap_CS_fsm : STD_LOGIC_VECTOR (1 downto 0) := "00";
    signal ap_sig_bdd_25 : BOOLEAN;
    signal tmp_V_fu_54_p1 : STD_LOGIC_VECTOR (15 downto 0);
    signal ap_NS_fsm : STD_LOGIC_VECTOR (1 downto 0);


begin




    -- the current state (ap_CS_fsm) of the state machine. --
    ap_CS_fsm_assign_proc : process(ap_clk)
    begin
        if (ap_clk'event and ap_clk =  '1') then
            if (ap_rst = '1') then
                ap_CS_fsm <= ap_ST_st1_fsm_0;
            else
                ap_CS_fsm <= ap_NS_fsm;
            end if;
        end if;
    end process;


    -- assign process. --
    process (ap_clk)
    begin
        if (ap_clk'event and ap_clk = '1') then
            if (((ap_ST_st2_fsm_1 = ap_CS_fsm) and not(ap_sig_bdd_25))) then
                tmp_V_1_reg_69 <= input_V_V_dout(31 downto 16);
            end if;
        end if;
    end process;

    -- the next state (ap_NS_fsm) of the state machine. --
    ap_NS_fsm_assign_proc : process (output_V_V_full_n , ap_CS_fsm , ap_sig_bdd_25)
    begin
        case ap_CS_fsm is
            when ap_ST_st1_fsm_0 => 
                ap_NS_fsm <= ap_ST_st2_fsm_1;
            when ap_ST_st2_fsm_1 => 
                if (not(ap_sig_bdd_25)) then
                    ap_NS_fsm <= ap_ST_st3_fsm_2;
                else
                    ap_NS_fsm <= ap_ST_st2_fsm_1;
                end if;
            when ap_ST_st3_fsm_2 => 
                if (not((output_V_V_full_n = ap_const_logic_0))) then
                    ap_NS_fsm <= ap_ST_st2_fsm_1;
                else
                    ap_NS_fsm <= ap_ST_st3_fsm_2;
                end if;
            when others =>  
                ap_NS_fsm <= "XX";
        end case;
    end process;

    -- ap_sig_bdd_25 assign process. --
    ap_sig_bdd_25_assign_proc : process(input_V_V_empty_n, output_V_V_full_n)
    begin
                ap_sig_bdd_25 <= ((input_V_V_empty_n = ap_const_logic_0) or (output_V_V_full_n = ap_const_logic_0));
    end process;


    -- input_V_V_read assign process. --
    input_V_V_read_assign_proc : process(ap_CS_fsm, ap_sig_bdd_25)
    begin
        if (((ap_ST_st2_fsm_1 = ap_CS_fsm) and not(ap_sig_bdd_25))) then 
            input_V_V_read <= ap_const_logic_1;
        else 
            input_V_V_read <= ap_const_logic_0;
        end if; 
    end process;


    -- output_V_V_din assign process. --
    output_V_V_din_assign_proc : process(output_V_V_full_n, tmp_V_1_reg_69, ap_CS_fsm, ap_sig_bdd_25, tmp_V_fu_54_p1)
    begin
        if (((ap_ST_st3_fsm_2 = ap_CS_fsm) and not((output_V_V_full_n = ap_const_logic_0)))) then 
            output_V_V_din <= tmp_V_1_reg_69;
        elsif (((ap_ST_st2_fsm_1 = ap_CS_fsm) and not(ap_sig_bdd_25))) then 
            output_V_V_din <= tmp_V_fu_54_p1;
        else 
            output_V_V_din <= "XXXXXXXXXXXXXXXX";
        end if; 
    end process;


    -- output_V_V_write assign process. --
    output_V_V_write_assign_proc : process(output_V_V_full_n, ap_CS_fsm, ap_sig_bdd_25)
    begin
        if ((((ap_ST_st2_fsm_1 = ap_CS_fsm) and not(ap_sig_bdd_25)) or ((ap_ST_st3_fsm_2 = ap_CS_fsm) and not((output_V_V_full_n = ap_const_logic_0))))) then 
            output_V_V_write <= ap_const_logic_1;
        else 
            output_V_V_write <= ap_const_logic_0;
        end if; 
    end process;

    tmp_V_fu_54_p1 <= input_V_V_dout(16 - 1 downto 0);
end behav;
